import { Injectable } from "@angular/core";
import { Http } from "@angular/http";

import * as wjcCore from "@grapecity/wijmo";
import * as wjcOdata from "@grapecity/wijmo.odata";

@Injectable({
	providedIn: "root"
})
export class DataService {
	url = "https://services.odata.org/Northwind/Northwind.svc";

	constructor(private http: Http) {}

	getCategories() {
		return new wjcOdata.ODataCollectionView(this.url, "Categories", {
			fields: ["CategoryID", "CategoryName", "Description"]
		});
	}

	getProduct(catId: number) {
		var view = new wjcCore.CollectionView([], {
			filter: function(item, prop) {
				return item.CategoryID == catId;
			}
		});

		// call any API here
		// simulating collection view
		this.http.get("https://api.myjson.com/bins/1130if").subscribe(res => {
			// change the source collection of collection view
			view.sourceCollection = res.json();
		});

		return view;
	}
}
